<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>6.7. readline — GNU readline interface &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="6. Text Processing Services" href="text.html" />
    <link rel="next" title="6.8. rlcompleter — Completion function for GNU readline" href="rlcompleter.html" />
    <link rel="prev" title="6.6. stringprep — Internet String Preparation" href="stringprep.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="rlcompleter.html" title="6.8. rlcompleter — Completion function for GNU readline"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="stringprep.html" title="6.6. stringprep — Internet String Preparation"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="text.html" accesskey="U">6. Text Processing Services</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-readline">
<span id="readline-gnu-readline-interface"></span><h1>6.7. <a class="reference internal" href="#module-readline" title="readline: GNU readline support for Python. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">readline</span></code></a> &#8212; GNU readline interface<a class="headerlink" href="#module-readline" title="Permalink to this headline">¶</a></h1>
<p>The <a class="reference internal" href="#module-readline" title="readline: GNU readline support for Python. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">readline</span></code></a> module defines a number of functions to facilitate
completion and reading/writing of history files from the Python interpreter.
This module can be used directly or via the <a class="reference internal" href="rlcompleter.html#module-rlcompleter" title="rlcompleter: Python identifier completion, suitable for the GNU readline library."><code class="xref py py-mod docutils literal"><span class="pre">rlcompleter</span></code></a> module.  Settings
made using  this module affect the behaviour of both the interpreter&#8217;s
interactive prompt  and the prompts offered by the built-in <a class="reference internal" href="functions.html#input" title="input"><code class="xref py py-func docutils literal"><span class="pre">input()</span></code></a>
function.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p>On MacOS X the <a class="reference internal" href="#module-readline" title="readline: GNU readline support for Python. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">readline</span></code></a> module can be implemented using
the <code class="docutils literal"><span class="pre">libedit</span></code> library instead of GNU readline.</p>
<p class="last">The configuration file for <code class="docutils literal"><span class="pre">libedit</span></code> is different from that
of GNU readline. If you programmatically load configuration strings
you can check for the text &#8220;libedit&#8221; in <code class="xref py py-const docutils literal"><span class="pre">readline.__doc__</span></code>
to differentiate between GNU readline and libedit.</p>
</div>
<p>The <a class="reference internal" href="#module-readline" title="readline: GNU readline support for Python. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">readline</span></code></a> module defines the following functions:</p>
<dl class="function">
<dt id="readline.parse_and_bind">
<code class="descclassname">readline.</code><code class="descname">parse_and_bind</code><span class="sig-paren">(</span><em>string</em><span class="sig-paren">)</span><a class="headerlink" href="#readline.parse_and_bind" title="Permalink to this definition">¶</a></dt>
<dd><p>Parse and execute single line of a readline init file.</p>
</dd></dl>

<dl class="function">
<dt id="readline.get_line_buffer">
<code class="descclassname">readline.</code><code class="descname">get_line_buffer</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.get_line_buffer" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the current contents of the line buffer.</p>
</dd></dl>

<dl class="function">
<dt id="readline.insert_text">
<code class="descclassname">readline.</code><code class="descname">insert_text</code><span class="sig-paren">(</span><em>string</em><span class="sig-paren">)</span><a class="headerlink" href="#readline.insert_text" title="Permalink to this definition">¶</a></dt>
<dd><p>Insert text into the command line.</p>
</dd></dl>

<dl class="function">
<dt id="readline.read_init_file">
<code class="descclassname">readline.</code><code class="descname">read_init_file</code><span class="sig-paren">(</span><span class="optional">[</span><em>filename</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.read_init_file" title="Permalink to this definition">¶</a></dt>
<dd><p>Parse a readline initialization file. The default filename is the last filename
used.</p>
</dd></dl>

<dl class="function">
<dt id="readline.read_history_file">
<code class="descclassname">readline.</code><code class="descname">read_history_file</code><span class="sig-paren">(</span><span class="optional">[</span><em>filename</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.read_history_file" title="Permalink to this definition">¶</a></dt>
<dd><p>Load a readline history file. The default filename is <code class="file docutils literal"><span class="pre">~/.history</span></code>.</p>
</dd></dl>

<dl class="function">
<dt id="readline.write_history_file">
<code class="descclassname">readline.</code><code class="descname">write_history_file</code><span class="sig-paren">(</span><span class="optional">[</span><em>filename</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.write_history_file" title="Permalink to this definition">¶</a></dt>
<dd><p>Save a readline history file. The default filename is <code class="file docutils literal"><span class="pre">~/.history</span></code>.</p>
</dd></dl>

<dl class="function">
<dt id="readline.append_history_file">
<code class="descclassname">readline.</code><code class="descname">append_history_file</code><span class="sig-paren">(</span><em>nelements</em><span class="optional">[</span>, <em>filename</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.append_history_file" title="Permalink to this definition">¶</a></dt>
<dd><p>Append the last <em>nelements</em> of history to a file.  The default filename is
<code class="file docutils literal"><span class="pre">~/.history</span></code>.  The file must already exist.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
</dd></dl>

<dl class="function">
<dt id="readline.clear_history">
<code class="descclassname">readline.</code><code class="descname">clear_history</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.clear_history" title="Permalink to this definition">¶</a></dt>
<dd><p>Clear the current history.  (Note: this function is not available if the
installed version of GNU readline doesn&#8217;t support it.)</p>
</dd></dl>

<dl class="function">
<dt id="readline.get_history_length">
<code class="descclassname">readline.</code><code class="descname">get_history_length</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.get_history_length" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the desired length of the history file.  Negative values imply unlimited
history file size.</p>
</dd></dl>

<dl class="function">
<dt id="readline.set_history_length">
<code class="descclassname">readline.</code><code class="descname">set_history_length</code><span class="sig-paren">(</span><em>length</em><span class="sig-paren">)</span><a class="headerlink" href="#readline.set_history_length" title="Permalink to this definition">¶</a></dt>
<dd><p>Set the number of lines to save in the history file. <a class="reference internal" href="#readline.write_history_file" title="readline.write_history_file"><code class="xref py py-func docutils literal"><span class="pre">write_history_file()</span></code></a>
uses this value to truncate the history file when saving.  Negative values imply
unlimited history file size.</p>
</dd></dl>

<dl class="function">
<dt id="readline.get_current_history_length">
<code class="descclassname">readline.</code><code class="descname">get_current_history_length</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.get_current_history_length" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the number of lines currently in the history.  (This is different from
<a class="reference internal" href="#readline.get_history_length" title="readline.get_history_length"><code class="xref py py-func docutils literal"><span class="pre">get_history_length()</span></code></a>, which returns the maximum number of lines that will
be written to a history file.)</p>
</dd></dl>

<dl class="function">
<dt id="readline.get_history_item">
<code class="descclassname">readline.</code><code class="descname">get_history_item</code><span class="sig-paren">(</span><em>index</em><span class="sig-paren">)</span><a class="headerlink" href="#readline.get_history_item" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the current contents of history item at <em>index</em>.</p>
</dd></dl>

<dl class="function">
<dt id="readline.remove_history_item">
<code class="descclassname">readline.</code><code class="descname">remove_history_item</code><span class="sig-paren">(</span><em>pos</em><span class="sig-paren">)</span><a class="headerlink" href="#readline.remove_history_item" title="Permalink to this definition">¶</a></dt>
<dd><p>Remove history item specified by its position from the history.</p>
</dd></dl>

<dl class="function">
<dt id="readline.replace_history_item">
<code class="descclassname">readline.</code><code class="descname">replace_history_item</code><span class="sig-paren">(</span><em>pos</em>, <em>line</em><span class="sig-paren">)</span><a class="headerlink" href="#readline.replace_history_item" title="Permalink to this definition">¶</a></dt>
<dd><p>Replace history item specified by its position with the given line.</p>
</dd></dl>

<dl class="function">
<dt id="readline.redisplay">
<code class="descclassname">readline.</code><code class="descname">redisplay</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.redisplay" title="Permalink to this definition">¶</a></dt>
<dd><p>Change what&#8217;s displayed on the screen to reflect the current contents of the
line buffer.</p>
</dd></dl>

<dl class="function">
<dt id="readline.set_startup_hook">
<code class="descclassname">readline.</code><code class="descname">set_startup_hook</code><span class="sig-paren">(</span><span class="optional">[</span><em>function</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.set_startup_hook" title="Permalink to this definition">¶</a></dt>
<dd><p>Set or remove the startup_hook function.  If <em>function</em> is specified, it will be
used as the new startup_hook function; if omitted or <code class="docutils literal"><span class="pre">None</span></code>, any hook function
already installed is removed.  The startup_hook function is called with no
arguments just before readline prints the first prompt.</p>
</dd></dl>

<dl class="function">
<dt id="readline.set_pre_input_hook">
<code class="descclassname">readline.</code><code class="descname">set_pre_input_hook</code><span class="sig-paren">(</span><span class="optional">[</span><em>function</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.set_pre_input_hook" title="Permalink to this definition">¶</a></dt>
<dd><p>Set or remove the pre_input_hook function.  If <em>function</em> is specified, it will
be used as the new pre_input_hook function; if omitted or <code class="docutils literal"><span class="pre">None</span></code>, any hook
function already installed is removed.  The pre_input_hook function is called
with no arguments after the first prompt has been printed and just before
readline starts reading input characters.</p>
</dd></dl>

<dl class="function">
<dt id="readline.set_completer">
<code class="descclassname">readline.</code><code class="descname">set_completer</code><span class="sig-paren">(</span><span class="optional">[</span><em>function</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.set_completer" title="Permalink to this definition">¶</a></dt>
<dd><p>Set or remove the completer function.  If <em>function</em> is specified, it will be
used as the new completer function; if omitted or <code class="docutils literal"><span class="pre">None</span></code>, any completer
function already installed is removed.  The completer function is called as
<code class="docutils literal"><span class="pre">function(text,</span> <span class="pre">state)</span></code>, for <em>state</em> in <code class="docutils literal"><span class="pre">0</span></code>, <code class="docutils literal"><span class="pre">1</span></code>, <code class="docutils literal"><span class="pre">2</span></code>, ..., until it
returns a non-string value.  It should return the next possible completion
starting with <em>text</em>.</p>
</dd></dl>

<dl class="function">
<dt id="readline.get_completer">
<code class="descclassname">readline.</code><code class="descname">get_completer</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.get_completer" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the completer function, or <code class="docutils literal"><span class="pre">None</span></code> if no completer function has been set.</p>
</dd></dl>

<dl class="function">
<dt id="readline.get_completion_type">
<code class="descclassname">readline.</code><code class="descname">get_completion_type</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.get_completion_type" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the type of completion being attempted.</p>
</dd></dl>

<dl class="function">
<dt id="readline.get_begidx">
<code class="descclassname">readline.</code><code class="descname">get_begidx</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.get_begidx" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the beginning index of the readline tab-completion scope.</p>
</dd></dl>

<dl class="function">
<dt id="readline.get_endidx">
<code class="descclassname">readline.</code><code class="descname">get_endidx</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.get_endidx" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the ending index of the readline tab-completion scope.</p>
</dd></dl>

<dl class="function">
<dt id="readline.set_completer_delims">
<code class="descclassname">readline.</code><code class="descname">set_completer_delims</code><span class="sig-paren">(</span><em>string</em><span class="sig-paren">)</span><a class="headerlink" href="#readline.set_completer_delims" title="Permalink to this definition">¶</a></dt>
<dd><p>Set the readline word delimiters for tab-completion.</p>
</dd></dl>

<dl class="function">
<dt id="readline.get_completer_delims">
<code class="descclassname">readline.</code><code class="descname">get_completer_delims</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.get_completer_delims" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the readline word delimiters for tab-completion.</p>
</dd></dl>

<dl class="function">
<dt id="readline.set_completion_display_matches_hook">
<code class="descclassname">readline.</code><code class="descname">set_completion_display_matches_hook</code><span class="sig-paren">(</span><span class="optional">[</span><em>function</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#readline.set_completion_display_matches_hook" title="Permalink to this definition">¶</a></dt>
<dd><p>Set or remove the completion display function.  If <em>function</em> is
specified, it will be used as the new completion display function;
if omitted or <code class="docutils literal"><span class="pre">None</span></code>, any completion display function already
installed is removed.  The completion display function is called as
<code class="docutils literal"><span class="pre">function(substitution,</span> <span class="pre">[matches],</span> <span class="pre">longest_match_length)</span></code> once
each time matches need to be displayed.</p>
</dd></dl>

<dl class="function">
<dt id="readline.add_history">
<code class="descclassname">readline.</code><code class="descname">add_history</code><span class="sig-paren">(</span><em>line</em><span class="sig-paren">)</span><a class="headerlink" href="#readline.add_history" title="Permalink to this definition">¶</a></dt>
<dd><p>Append a line to the history buffer, as if it was the last line typed.</p>
</dd></dl>

<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt>Module <a class="reference internal" href="rlcompleter.html#module-rlcompleter" title="rlcompleter: Python identifier completion, suitable for the GNU readline library."><code class="xref py py-mod docutils literal"><span class="pre">rlcompleter</span></code></a></dt>
<dd>Completion of Python identifiers at the interactive prompt.</dd>
</dl>
</div>
<div class="section" id="example">
<span id="readline-example"></span><h2>6.7.1. Example<a class="headerlink" href="#example" title="Permalink to this headline">¶</a></h2>
<p>The following example demonstrates how to use the <a class="reference internal" href="#module-readline" title="readline: GNU readline support for Python. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">readline</span></code></a> module&#8217;s
history reading and writing functions to automatically load and save a history
file named <code class="file docutils literal"><span class="pre">.python_history</span></code> from the user&#8217;s home directory.  The code
below would normally be executed automatically during interactive sessions
from the user&#8217;s <span class="target" id="index-0"></span><a class="reference internal" href="../using/cmdline.html#envvar-PYTHONSTARTUP"><code class="xref std std-envvar docutils literal"><span class="pre">PYTHONSTARTUP</span></code></a> file.</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">atexit</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">readline</span>

<span class="n">histfile</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">expanduser</span><span class="p">(</span><span class="s">&quot;~&quot;</span><span class="p">),</span> <span class="s">&quot;.python_history&quot;</span><span class="p">)</span>
<span class="k">try</span><span class="p">:</span>
    <span class="n">readline</span><span class="o">.</span><span class="n">read_history_file</span><span class="p">(</span><span class="n">histfile</span><span class="p">)</span>
    <span class="c"># default history len is -1 (infinite), which may grow unruly</span>
    <span class="n">readline</span><span class="o">.</span><span class="n">set_history_length</span><span class="p">(</span><span class="mi">1000</span><span class="p">)</span>
<span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
    <span class="k">pass</span>

<span class="n">atexit</span><span class="o">.</span><span class="n">register</span><span class="p">(</span><span class="n">readline</span><span class="o">.</span><span class="n">write_history_file</span><span class="p">,</span> <span class="n">histfile</span><span class="p">)</span>
</pre></div>
</div>
<p>This code is actually automatically run when Python is run in
<a class="reference internal" href="../tutorial/interpreter.html#tut-interactive"><span>interactive mode</span></a> (see <a class="reference internal" href="site.html#rlcompleter-config"><span>Readline configuration</span></a>).</p>
<p>The following example achieves the same goal but supports concurrent interactive
sessions, by only appending the new history.</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">atexit</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">readline</span>
<span class="n">histfile</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">expanduser</span><span class="p">(</span><span class="s">&quot;~&quot;</span><span class="p">),</span> <span class="s">&quot;.python_history&quot;</span><span class="p">)</span>

<span class="k">try</span><span class="p">:</span>
    <span class="n">readline</span><span class="o">.</span><span class="n">read_history_file</span><span class="p">(</span><span class="n">histfile</span><span class="p">)</span>
    <span class="n">h_len</span> <span class="o">=</span> <span class="n">readline</span><span class="o">.</span><span class="n">get_history_length</span><span class="p">()</span>
<span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
    <span class="nb">open</span><span class="p">(</span><span class="n">histfile</span><span class="p">,</span> <span class="s">&#39;wb&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
    <span class="n">h_len</span> <span class="o">=</span> <span class="mi">0</span>

<span class="k">def</span> <span class="nf">save</span><span class="p">(</span><span class="n">prev_h_len</span><span class="p">,</span> <span class="n">histfile</span><span class="p">):</span>
    <span class="n">new_h_len</span> <span class="o">=</span> <span class="n">readline</span><span class="o">.</span><span class="n">get_history_length</span><span class="p">()</span>
    <span class="n">readline</span><span class="o">.</span><span class="n">set_history_length</span><span class="p">(</span><span class="mi">1000</span><span class="p">)</span>
    <span class="n">readline</span><span class="o">.</span><span class="n">append_history_file</span><span class="p">(</span><span class="n">new_h_len</span> <span class="o">-</span> <span class="n">prev_h_len</span><span class="p">,</span> <span class="n">histfile</span><span class="p">)</span>
<span class="n">atexit</span><span class="o">.</span><span class="n">register</span><span class="p">(</span><span class="n">save</span><span class="p">,</span> <span class="n">h_len</span><span class="p">,</span> <span class="n">histfile</span><span class="p">)</span>
</pre></div>
</div>
<p>The following example extends the <a class="reference internal" href="code.html#code.InteractiveConsole" title="code.InteractiveConsole"><code class="xref py py-class docutils literal"><span class="pre">code.InteractiveConsole</span></code></a> class to
support history save/restore.</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">atexit</span>
<span class="kn">import</span> <span class="nn">code</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">readline</span>

<span class="k">class</span> <span class="nc">HistoryConsole</span><span class="p">(</span><span class="n">code</span><span class="o">.</span><span class="n">InteractiveConsole</span><span class="p">):</span>
    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="nb">locals</span><span class="o">=</span><span class="k">None</span><span class="p">,</span> <span class="n">filename</span><span class="o">=</span><span class="s">&quot;&lt;console&gt;&quot;</span><span class="p">,</span>
                 <span class="n">histfile</span><span class="o">=</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">expanduser</span><span class="p">(</span><span class="s">&quot;~/.console-history&quot;</span><span class="p">)):</span>
        <span class="n">code</span><span class="o">.</span><span class="n">InteractiveConsole</span><span class="o">.</span><span class="n">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="nb">locals</span><span class="p">,</span> <span class="n">filename</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">init_history</span><span class="p">(</span><span class="n">histfile</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">init_history</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">histfile</span><span class="p">):</span>
        <span class="n">readline</span><span class="o">.</span><span class="n">parse_and_bind</span><span class="p">(</span><span class="s">&quot;tab: complete&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">readline</span><span class="p">,</span> <span class="s">&quot;read_history_file&quot;</span><span class="p">):</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">readline</span><span class="o">.</span><span class="n">read_history_file</span><span class="p">(</span><span class="n">histfile</span><span class="p">)</span>
            <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
                <span class="k">pass</span>
            <span class="n">atexit</span><span class="o">.</span><span class="n">register</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">save_history</span><span class="p">,</span> <span class="n">histfile</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">save_history</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">histfile</span><span class="p">):</span>
        <span class="n">readline</span><span class="o">.</span><span class="n">set_history_length</span><span class="p">(</span><span class="mi">1000</span><span class="p">)</span>
        <span class="n">readline</span><span class="o">.</span><span class="n">write_history_file</span><span class="p">(</span><span class="n">histfile</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">6.7. <code class="docutils literal"><span class="pre">readline</span></code> &#8212; GNU readline interface</a><ul>
<li><a class="reference internal" href="#example">6.7.1. Example</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="stringprep.html"
                        title="previous chapter">6.6. <code class="docutils literal"><span class="pre">stringprep</span></code> &#8212; Internet String Preparation</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="rlcompleter.html"
                        title="next chapter">6.8. <code class="docutils literal"><span class="pre">rlcompleter</span></code> &#8212; Completion function for GNU readline</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/readline.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="rlcompleter.html" title="6.8. rlcompleter — Completion function for GNU readline"
             >next</a> |</li>
        <li class="right" >
          <a href="stringprep.html" title="6.6. stringprep — Internet String Preparation"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="text.html" >6. Text Processing Services</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 11, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>